/**
 * Handles the Window.
 */
export default class AsyncTaskManager {
    private isDisposed;
    private asyncTaskCount;
    private hasAsyncError;
    private asyncTimeout;
    private asyncPromises;
    /**
     * Returns a promise that is fulfilled when async tasks are complete.
     * This method is not part of the HTML standard.
     *
     * @return {Promise<void>} Promise.
     */
    whenComplete(): Promise<void>;
    /**
     * Disposes the window.
     */
    dispose(): void;
    /**
     * Starts an async task.
     */
    private startAsyncTask;
    /**
     * Ends an async task.
     *
     * @param {Error} [error] Error.
     */
    private endAsyncTask;
}
