/**
 * Handles async tasks.
 */
export default class AsyncTaskManager {
    private isDisposed;
    private tasks;
    private hasError;
    private timeout;
    private queue;
    /**
     * Returns a promise that is fulfilled when async tasks are complete.
     * This method is not part of the HTML standard.
     *
     * @return {Promise<void>} Promise.
     */
    whenComplete(): Promise<void>;
    /**
     * Disposes the window.
     */
    dispose(): void;
    /**
     * Starts an async task.
     *
     * @param {string} name Name of task.
     */
    startTask(name: string): void;
    /**
     * Ends an async task.
     *
     * @param {string} name Name of task.
     * @param {Error} [error] Error.
     */
    endTask(name: string, error?: Error): void;
}
