import HTMLInputElement from '../nodes/elements/HTMLInputElement';
/**
 * Input validity state.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/API/ValidityState
 */
export default class ValidityState {
    badInput: boolean;
    customError: boolean;
    patternMismatch: boolean;
    rangeOverflow: boolean;
    rangeUnderflow: boolean;
    stepMismatch: boolean;
    private element;
    /**
     * Constructor.
     *
     * @param {HTMLInputElement} element Input element.
     */
    constructor(element: HTMLInputElement);
    /**
     * Returns validity.
     *
     * @return {boolean} "true" if valid.
     */
    readonly tooLong: boolean;
    /**
     * Returns validity.
     *
     * @return {boolean} "true" if valid.
     */
    readonly tooShort: boolean;
    /**
     * Returns validity.
     *
     * @return {boolean} "true" if valid.
     */
    readonly typeMismatch: boolean;
    /**
     * Returns validity.
     *
     * @return {boolean} "true" if valid.
     */
    readonly valueMissing: boolean;
    /**
     * Returns validity.
     *
     * @return {boolean} "true" if valid.
     */
    readonly valid: boolean;
}
