"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Document_1 = __importDefault(require("../nodes/basic-types/document/Document"));
/**
 * The DOMImplementation interface represents an object providing methods which are not dependent on any particular document. Such an object is returned by the
 */
var DOMImplementation = /** @class */ (function () {
    /**
     * Constructor.
     *
     * @param {Window} window Window.
     */
    function DOMImplementation(window) {
        this.window = window;
    }
    /**
     * Creates and returns an HTML Document.
     */
    DOMImplementation.prototype.createHTMLDocument = function () {
        return new Document_1.default(this.window);
    };
    return DOMImplementation;
}());
exports.default = DOMImplementation;
//# sourceMappingURL=DOMImplementation.js.map