export default class URL {
    protocol: string;
    hostname: string;
    port: string;
    pathname: string;
    search: string;
    hash: string;
    username: string;
    password: string;
    /**
     * Constructor.
     *
     * @param {string} url URL.
     */
    constructor(url: string);
    /**
     * Returns the entire URL as a string.
     */
    toString(): string;
    /**
     * Parses an URL.
     *
     * @param {string} url URL.
     */
    protected parse(url: string): void;
    /**
     * Returns the entire URL as a string.
     *
     * @return {string} Href.
     */
    /**
    * Sets the href.
    *
    * @param {string} url URL.
    */
    href: string;
    /**
     * Returns the origin.
     *
     * @return {string} HREF.
     */
    readonly origin: string;
    /**
     * Returns the entire URL as a string.
     *
     * @return {string} Host.
     */
    readonly host: string;
}
