import Element from './Element';
/**
 * HTMLElement.
 */
export default class HTMLElement extends Element {
    protected static _observedPropertyAttributes: {
        [k: string]: string;
    };
    style: object;
    tabIndex: number;
    offsetHeight: number;
    offsetWidth: number;
    offsetLeft: number;
    offsetTop: number;
    /**
     * Returns inner text.
     *
     * @return {string} Text.
     */
    /**
    * Sets inner text.
    *
    * @param {string} text Text.
    */
    innerText: string;
    /**
     * Blur.
     */
    blur(): void;
    /**
     * Click.
     */
    click(): void;
    /**
     * Focus.
     */
    focus(): void;
    /**
     * Sets an attribute.
     *
     * @override
     * @param {string} name Name.
     * @param {string} value Value.
     */
    setAttribute(name: string, value: string): void;
    /**
     * Sets raw attributes.
     *
     * @override
     * @param {string} rawAttributes Raw attributes.
     */
    _setRawAttributes(rawAttributes: string): void;
    /**
     * Defines initial properties.
     */
    private _defineInitialProperties;
}
