import Element from './Element';
/**
 * Class list.
 */
export default class ClassList {
    private ownerElement;
    /**
     * Adds class names.
     *
     * @param {Element} ownerElement Owner element.
     */
    constructor(ownerElement: Element);
    /**
     * Adds class names.
     *
     * @param {string[]} classNames Class names.
     */
    add(...classNames: string[]): void;
    /**
     * Adds class names.
     *
     * @param {string[]} classNames Class names.
     */
    remove(...classNames: string[]): void;
    /**
     * Check if the list contains a class.
     *
     * @param {string} className Class name.
     * @return {boolean} TRUE if it contains.
     */
    contains(className: string): boolean;
}
