import Node from '../node/Node';
import NodeType from '../node/NodeType';
/**
 * TextNode.
 */
export default class TextNode extends Node {
    readonly nodeType = NodeType.TEXT_NODE;
    protected _textContent: string;
    /**
     * Converts to string.
     *
     * @return {string} String.
     */
    toString(): string;
    /**
     * Node name.
     *
     * @return {string} Node name.
     */
    readonly nodeName: string;
    /**
     * Returns text content.
     *
     * @return {string} Text content.
     */
    /**
    * Sets text content.
    *
    * @param {string} textContent Text content.
    */
    textContent: string;
    /**
     * Returns node value.
     *
     * @return {string} Node value.
     */
    /**
    * Sets node value.
    *
    * @param {string} nodeValue Node value.
    */
    nodeValue: string;
    /**
     * Returns data.
     *
     * @return {string} Data.
     */
    /**
    * Sets data.
    *
    * @param {string} data Data.
    */
    data: string;
}
